package ru.octol1ttle.knockdowns.mixin;

import com.llamalad7.mixinextras.injector.ModifyExpressionValue;
import com.llamalad7.mixinextras.injector.ModifyReturnValue;
import java.util.UUID;
import net.minecraft.entity.player.PlayerEntity;
import org.spongepowered.asm.mixin.Mixin;
import org.spongepowered.asm.mixin.Unique;
import org.spongepowered.asm.mixin.injection.At;
import ru.octol1ttle.knockdowns.api.IKnockableDown;

@Mixin(PlayerEntity.class)
public abstract class PlayerEntityMixin implements IKnockableDown {
    @Unique
    private boolean knockedDown;
    @Unique
    private boolean beingRevived;
    @Unique
    private int reviveAt;

    @ModifyExpressionValue(method = "updatePose", at = @At(value = "INVOKE", target = "Lnet/minecraft/entity/player/PlayerEntity;isSwimming()Z"))
    private boolean isKnockedDown(boolean original) {
        PlayerEntity player = (PlayerEntity)(Object)this;
        if (!(player instanceof IKnockableDown knockableDown)) {
            throw new IllegalStateException();
        }

        return original || knockableDown.knockdowns$isKnockedDown();
    }

    @ModifyReturnValue(method = "canFoodHeal", at = @At("RETURN"))
    private boolean canFoodHeal(boolean original) {
        return original && !this.knockdowns$isKnockedDown();
    }

    @Override
    public boolean knockdowns$isKnockedDown() {
        return knockedDown;
    }

    @Override
    public void knockdowns$setKnockedDown(boolean knockedDown) {
        this.knockedDown = knockedDown;
    }

    @Override
    public boolean knockdowns$isBeingRevived() {
        return beingRevived;
    }

    @Override
    public void knockdowns$setBeingRevived(boolean beingRevived) {
        this.beingRevived = beingRevived;
    }

    @Override
    public UUID knockdowns$getUuid() {
        return ((PlayerEntity)(Object)this).getUuid();
    }
}
